FixedTempoEstimator::D Class Reference

## Public Member Functions

| D (float inputSampleRate)
| ~D ()
size_t | getPreferredStepSize () const
size_t | getPreferredBlockSize () const
ParameterList | getParameterDescriptors () const
float | getParameter (string id) const
void | setParameter (string id, float value)
OutputList | getOutputDescriptors () const
bool | initialise (size_t channels, size_t stepSize, size_t blockSize)
void | reset ()
FeatureSet | process (const float *const *, RealTime)
FeatureSet | getRemainingFeatures ()

## Private Member Functions

void | calculate ()
FeatureSet | assembleFeatures ()
float | lag2tempo (int)
int | tempo2lag (float)

## Private Attributes

float | m_inputSampleRate
size_t | m_stepSize
size_t | m_blockSize
float | m_minbpm
float | m_maxbpm
float | m_maxdflen
float * | m_priorMagnitudes
size_t | m_dfsize
float * | m_df
float * | m_r
float * | m_fr
float * | m_t
size_t | m_n
Vamp::RealTime | m_start
Vamp::RealTime | m_lasttime

## Detailed Description

Definition at line 50 of file FixedTempoEstimator.cpp.

## Constructor & Destructor Documentation

## D()

FixedTempoEstimator::D::D | ( | float | inputSampleRate | ) |

Definition at line 99 of file FixedTempoEstimator.cpp.

References m_blockSize, m_df, m_fr, m_inputSampleRate, m_maxbpm, m_maxdflen, m_minbpm, m_n, m_priorMagnitudes, m_r, m_stepSize, and m_t.

## ~D()

FixedTempoEstimator::D::~D | ( |  | ) |

Definition at line 115 of file FixedTempoEstimator.cpp.

References m_df, m_fr, m_priorMagnitudes, m_r, and m_t.

## Member Function Documentation

## getPreferredStepSize()

size_t FixedTempoEstimator::D::getPreferredStepSize | ( |  | ) | const

inline

Definition at line 57 of file FixedTempoEstimator.cpp.

## getPreferredBlockSize()

size_t FixedTempoEstimator::D::getPreferredBlockSize | ( |  | ) | const

inline

Definition at line 58 of file FixedTempoEstimator.cpp.

## getParameterDescriptors()

FixedTempoEstimator::ParameterList FixedTempoEstimator::D::getParameterDescriptors | ( |  | ) | const

Definition at line 125 of file FixedTempoEstimator.cpp.

References Vamp::PluginBase::ParameterDescriptor::defaultValue, Vamp::PluginBase::ParameterDescriptor::description, Vamp::PluginBase::ParameterDescriptor::identifier, Vamp::PluginBase::ParameterDescriptor::isQuantized, Vamp::PluginBase::ParameterDescriptor::maxValue, Vamp::PluginBase::ParameterDescriptor::minValue, Vamp::PluginBase::ParameterDescriptor::name, and Vamp::PluginBase::ParameterDescriptor::unit.

## getParameter()

float FixedTempoEstimator::D::getParameter | ( | string | id | ) | const

Definition at line 159 of file FixedTempoEstimator.cpp.

References m_maxbpm, m_maxdflen, and m_minbpm.

## setParameter()

void FixedTempoEstimator::D::setParameter | ( | string | id,
|  | float | value )

Definition at line 172 of file FixedTempoEstimator.cpp.

References m_maxbpm, m_maxdflen, and m_minbpm.

## getOutputDescriptors()

FixedTempoEstimator::OutputList FixedTempoEstimator::D::getOutputDescriptors | ( |  | ) | const

Definition at line 190 of file FixedTempoEstimator.cpp.

References Vamp::Plugin::OutputDescriptor::binCount, Vamp::Plugin::OutputDescriptor::description, FixedTempoEstimator::getPreferredBlockSize(), Vamp::Plugin::OutputDescriptor::hasDuration, Vamp::Plugin::OutputDescriptor::hasFixedBinCount, Vamp::Plugin::OutputDescriptor::hasKnownExtents, Vamp::Plugin::OutputDescriptor::identifier, Vamp::Plugin::OutputDescriptor::isQuantized, m_inputSampleRate, m_stepSize, Vamp::Plugin::OutputDescriptor::maxValue, Vamp::Plugin::OutputDescriptor::minValue, Vamp::Plugin::OutputDescriptor::name, Vamp::Plugin::OutputDescriptor::quantizeStep, Vamp::Plugin::OutputDescriptor::sampleRate, Vamp::Plugin::OutputDescriptor::sampleType, and Vamp::Plugin::OutputDescriptor::unit.

## initialise()

bool FixedTempoEstimator::D::initialise | ( | size_t | channels,
|  | size_t | stepSize,
|  | size_t | blockSize )

Definition at line 252 of file FixedTempoEstimator.cpp.

References m_blockSize, m_df, m_dfsize, m_inputSampleRate, m_maxdflen, m_n, m_priorMagnitudes, and m_stepSize.

## reset()

void FixedTempoEstimator::D::reset | ( |  | ) |

Definition at line 276 of file FixedTempoEstimator.cpp.

References m_blockSize, m_df, m_dfsize, m_fr, m_lasttime, m_n, m_priorMagnitudes, m_r, m_start, m_t, and Vamp::RealTime::zeroTime.

## process()

FixedTempoEstimator::FeatureSet FixedTempoEstimator::D::process | ( | const float *const * | inputBuffers,
|  | RealTime | ts )

Definition at line 303 of file FixedTempoEstimator.cpp.

References assembleFeatures(), calculate(), m_blockSize, m_df, m_dfsize, m_lasttime, m_n, m_priorMagnitudes, m_start, and m_stepSize.

## getRemainingFeatures()

FixedTempoEstimator::FeatureSet FixedTempoEstimator::D::getRemainingFeatures | ( |  | ) |

Definition at line 352 of file FixedTempoEstimator.cpp.

References assembleFeatures(), calculate(), m_dfsize, and m_n.

## calculate()

void FixedTempoEstimator::D::calculate | ( |  | ) |

private

Definition at line 375 of file FixedTempoEstimator.cpp.

References lag2tempo(), m_df, m_dfsize, m_fr, m_inputSampleRate, m_n, m_r, m_stepSize, and m_t.

Referenced by getRemainingFeatures(), and process().

## assembleFeatures()

FixedTempoEstimator::FeatureSet FixedTempoEstimator::D::assembleFeatures | ( |  | ) |

private

Definition at line 481 of file FixedTempoEstimator.cpp.

References ACFOutput, CandidatesOutput, DFOutput, Vamp::Plugin::Feature::duration, FilteredACFOutput, Vamp::RealTime::frame2RealTime(), Vamp::Plugin::Feature::hasDuration, Vamp::Plugin::Feature::hasTimestamp, Vamp::Plugin::Feature::label, lag2tempo(), m_df, m_fr, m_inputSampleRate, m_lasttime, m_maxbpm, m_minbpm, m_n, m_r, m_start, m_stepSize, m_t, tempo2lag(), TempoOutput, Vamp::Plugin::Feature::timestamp, and Vamp::Plugin::Feature::values.

Referenced by getRemainingFeatures(), and process().

## lag2tempo()

float FixedTempoEstimator::D::lag2tempo | ( | int | lag | ) |

private

Definition at line 363 of file FixedTempoEstimator.cpp.

References m_inputSampleRate, and m_stepSize.

Referenced by assembleFeatures(), and calculate().

## tempo2lag()

int FixedTempoEstimator::D::tempo2lag | ( | float | tempo | ) |

private

Definition at line 369 of file FixedTempoEstimator.cpp.

References m_inputSampleRate, and m_stepSize.

Referenced by assembleFeatures().

## Member Data Documentation

## m_inputSampleRate

float FixedTempoEstimator::D::m_inputSampleRate

private

Definition at line 78 of file FixedTempoEstimator.cpp.

Referenced by assembleFeatures(), calculate(), D(), getOutputDescriptors(), initialise(), lag2tempo(), and tempo2lag().

## m_stepSize

size_t FixedTempoEstimator::D::m_stepSize

private

Definition at line 79 of file FixedTempoEstimator.cpp.

Referenced by assembleFeatures(), calculate(), D(), getOutputDescriptors(), initialise(), lag2tempo(), process(), and tempo2lag().

## m_blockSize

size_t FixedTempoEstimator::D::m_blockSize

private

Definition at line 80 of file FixedTempoEstimator.cpp.

Referenced by D(), initialise(), process(), and reset().

## m_minbpm

float FixedTempoEstimator::D::m_minbpm

private

Definition at line 82 of file FixedTempoEstimator.cpp.

Referenced by assembleFeatures(), D(), getParameter(), and setParameter().

## m_maxbpm

float FixedTempoEstimator::D::m_maxbpm

private

Definition at line 83 of file FixedTempoEstimator.cpp.

Referenced by assembleFeatures(), D(), getParameter(), and setParameter().

## m_maxdflen

float FixedTempoEstimator::D::m_maxdflen

private

Definition at line 84 of file FixedTempoEstimator.cpp.

Referenced by D(), getParameter(), initialise(), and setParameter().

## m_priorMagnitudes

float* FixedTempoEstimator::D::m_priorMagnitudes

private

Definition at line 86 of file FixedTempoEstimator.cpp.

Referenced by D(), initialise(), process(), reset(), and ~D().

## m_dfsize

size_t FixedTempoEstimator::D::m_dfsize

private

Definition at line 88 of file FixedTempoEstimator.cpp.

Referenced by calculate(), getRemainingFeatures(), initialise(), process(), and reset().

## m_df

float* FixedTempoEstimator::D::m_df

private

Definition at line 89 of file FixedTempoEstimator.cpp.

Referenced by assembleFeatures(), calculate(), D(), initialise(), process(), reset(), and ~D().

## m_r

float* FixedTempoEstimator::D::m_r

private

Definition at line 90 of file FixedTempoEstimator.cpp.

Referenced by assembleFeatures(), calculate(), D(), reset(), and ~D().

## m_fr

float* FixedTempoEstimator::D::m_fr

private

Definition at line 91 of file FixedTempoEstimator.cpp.

Referenced by assembleFeatures(), calculate(), D(), reset(), and ~D().

## m_t

float* FixedTempoEstimator::D::m_t

private

Definition at line 92 of file FixedTempoEstimator.cpp.

Referenced by assembleFeatures(), calculate(), D(), reset(), and ~D().

## m_n

size_t FixedTempoEstimator::D::m_n

private

Definition at line 93 of file FixedTempoEstimator.cpp.

Referenced by assembleFeatures(), calculate(), D(), getRemainingFeatures(), initialise(), process(), and reset().

## m_start

Vamp::RealTime FixedTempoEstimator::D::m_start

private

Definition at line 95 of file FixedTempoEstimator.cpp.

Referenced by assembleFeatures(), process(), and reset().

## m_lasttime

Vamp::RealTime FixedTempoEstimator::D::m_lasttime

private

Definition at line 96 of file FixedTempoEstimator.cpp.

Referenced by assembleFeatures(), process(), and reset().

The documentation for this class was generated from the following file:

- FixedTempoEstimator.cpp